<template>
    <div>
        <div
            class="uk-inline"
            v-bind:style="{ width: size + 'px', height: size + 'px' }"
        >
            <div :id="boardName" class="board-probleme" />
            <Resultat
                :afficher="exoValide || enErreur"
                :avecErreur="enErreur"
                :texteHaut="texteAAfficher"
                @reinitialiserProbleme="reinitialiser"
            />
        </div>
    </div>
</template>

<script lang="ts">
// @ts-ignore
import WGo from 'wgo';
import Goban from '@/components/goban/GobanProbleme.vue';
import Component, { mixins } from 'vue-class-component';
import Resultat from '@/components/jeu/Resultat.vue';
import { Prop } from 'vue-property-decorator';
@Component({
    components: { Resultat }
})
export default class GobanChoixMultiple extends mixins(Goban) {
    @Prop() solution: any[];

    public getListener() {
        return (x, y) => {}; //on clique sur les choix, pas le goban
    }

    public async afficherResultatCorrect() {
        let itemsProcessed = 0;

        this.solution[0].coups.forEach((item, index, array) => {
            this.jouerExplication(item, index, () => {
                itemsProcessed++;
                if (itemsProcessed === array.length) {
                    this.exoValide = true;
                }
            });
        });
        this.$emit('envoyerResultat', true);
    }

    private jouerExplication(coup, index, callback) {
        setTimeout(() => {
            this.coupStandard(coup.abscisse, coup.ordonnee);
            this.$emit('afficherCommentaire', coup.commentaire);
            callback();
        }, index * 500);
    }

    public afficherErreur() {
        this.enErreur = true;
        this.$emit('envoyerResultat', false);
    }

    get texteAAfficher() {
        if (this.exoValide) {
            return 'Vrai ! ';
        }
        return 'Faux !';
    }

    public reinitialiser() {
        this.exoValide = false;
        this.enErreur = false;
        this.board.removeAllObjects();
        this.setGame();
        this.afficherSituationInitiale();
        this.afficherMarqueursInitiaux();
        this.tool = WGo.B;
        this.$emit('reinitialiser');
        this.$emit('afficherCommentaire');
    }
}
</script>

<style>
.board-probleme {
    position: absolute;
    z-index: 0;
}
</style>
